# Often Confused Terms

There are many terms that are very similar and are sometimes used interchangeably. This isn't wrong per se, a slight difference may be insignificant in certain contexts. However it's good to know the differences for those cases when they matter. The following list tries to document some of the often confused terms.

- **[AI](ai.md)** vs **[machine learning](machine_learning.md)**
- **[algebra](algebra.md)** vs **[arithmetic](arithmetic.md)**
- **[algorithm](algorithm.md)** vs **[program](program.md)**
- **[analog](analog.md)** vs **[mechanical](mechanical.md)**
- **[anarchy](anarchism.md)** vs **[chaos](chaos.md)**
- **[argument](argument.md)** vs **[parameter](parameter.md)**
- **binary** vs **[executable](executable.md)**
- **[array](array.md)** vs **[list](list.md)**
- **[cepstrum](cepstrum.md)** vs **[spectrum](spectrum.md)**
- **[assembler](assembler.md)** vs **[assembly](assembly.md)**
- **[causation](causation.md)** vs **[correlation](correlation.md)**
- **[chaos](chaos.md)** vs **[randomness](random.md)** vs **[pseudorandomness](pseudorandom.md)** vs **[entropy](entropy.md)**
- **[class](class.md)** vs **[set](set.md)**
- **[closed source](closed_source.md)** vs **[proprietary](proprietary.md)**
- **[CLI](cli.md)** vs **[TUI](tui.md)** vs **[terminal](terminal_emulator.md)** vs **[console](console.md)**
- **[color model](color_model.md)** vs **[color space](color_space.md)**
- **[communism](communism.md)** vs **[Marxism](marxism.md)**
- **[computer language](computer_language.md)** vs **[programming language](programming_language.md)**
- **[computer science](compsci.md)** vs **[information technology](it.md)** vs **[informatics](informatics.md)**
- **[concurrency](concurrency.md)** vs **[parallelism](parallelism.md)**
- **[constant](constant.md)** vs **[literal](literal.md)**
- **[coding](coding.md)** vs **[programming](programming.md)**
- **[codec](codec.md)** vs **[container format](container_format.md)**
- **[coherence](coherence.md)** vs **[consistency](consistency.md)**
- **[convolution](convolution.md)** vs **[correlation](correlation.md)**
- **[copyright](copyright.md)** vs **[patent](patent.md)** vs **[trademark](trademark.md)**
- **[crossplatform/multiplatform](multiplatform.md)** vs **[portable](portability.md)**
- **[cryptography](cryptography.md)** vs **[security](security.md)**
- **[data](data.md)** vs **[information](information.md)**
- **[data structure](data_structure.md)** vs **[data type](data_type.md)**
- **[decentralized](decentralization.md)** vs **[distributed](distributed.md)**
- **[declaration](declaration.md)** vs **[definition](definition.md)**
- **[digital](digital.md)** vs **[electronic](electronics.md)**
- **[directed acyclic graph](dag.md)** vs **[tree](tree.md)**
- **[directory](directory.md)** vs **[folder](folder.md)**
- **[discrete Fourier transform](dft.md)** vs **[discrete time Fourier transform](dtft.md)**
- **[emulation](emulation.md)** vs **[simulation](simulation.md)**
- **[equation](equation.md)** vs **[expression](expression.md)** vs **[inequality](inequality.md)**
- **[equivalence](equivalence.md)** vs **[implication](implication.md)**
- **[error](error.md)** vs **[exception](exception.md)** vs **[fault](fault.md)** vs **[failure](fail.md)**
- **[evolutionary programming](evolutionary.md)** vs **[evolutionary algorithm](evolutionary.md)** vs **[genetic programming](genetic_programming.md)** vs **[genetic algorithm](genetic_algorithm.md)**
- **[floating point number](float.md)** vs **[real number](real_number.md)**
- **[font](font.md)** vs **[typeface](typeface.md)**
- **[free software](free_software.md)** vs **[open source](open_source.md)** vs **[public domain](public_domain.md)** vs **[source available](source_available.md)** vs **[freeware](freeware.md)**
- **[geek](geek.md)** vs **[nerd](nerd.md)**
- **[GNU](gnu.md)/Linux** vs **[Linux](linux.md)**
- **[hypothesis](hypothesis.md)** vs **[theory](theory.md)** vs **[conjecture](conjecture.md)**
- **[ID](id.md)** vs **[token](token.md)** vs **[hash](hash.md)** vs **[handle](handle.md)** vs **[identifier](identifier.md)**
- **[infinite](infinity.md)** vs **[arbitrarily large/unbounded](unbounded.md)**
- **[internet](internet.md)** vs **[web](web.md)**
- **[Java](java.md)** vs **[JavaScript](js.md)**
- **[kB/mB/gB/tB](memory_units.md)** vs **[KiB/MiB/GiB/TiB](memory_units.md)**
- **[latency/ping/lag](latency.md)** vs **[throughput/bandwidth](throughput.md)**
- **[leftism](left_right.md)** vs **[pseudoleftism](pseudoleft.md)**
- **[method](method.md)** vs **[methodology](methodology.md)**
- **[modem](modem.md)** vs **[router](router.md)**
- **[NP](p_vs_np.md)** vs **[NP-hard](np_hard.md)**
- **[path tracing](path_tracing.md)** vs **[ray tracing](ray_tracing.md)** vs **[ray casting](ray_casting.md)**
- **[principal square root](principal_sqrt.md)** vs **[square root](sqrt.md)** (especially when defining [i](i.md))
- **[probability](probability.md)** vs **[probability density](probability_density.md)**
- **[pointer](pointer.md)** vs **[reference](reference.md)**
- **[shading](shading.md)** vs **[shadows](shadow.md)**
- **[science](science.md)** vs **[soyence](soyence.md)**
- **[Unicode](unicode.md)** vs **[UTF](utf.md)**
- **[webpage](webpage.md)** vs **[website](website.md)**